/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreVariableSegmentRecord;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreVariableSegment extends TableImpl<TCoreVariableSegmentRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_variable_segment</code>
     */
    public static final TCoreVariableSegment T_CORE_VARIABLE_SEGMENT = new TCoreVariableSegment();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreVariableSegmentRecord> getRecordType() {
        return TCoreVariableSegmentRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_variable_segment.pk</code>.
     */
    public final TableField<TCoreVariableSegmentRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_variable_segment.fk_element</code>.
     */
    public final TableField<TCoreVariableSegmentRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_variable_segment.name</code>.
     */
    public final TableField<TCoreVariableSegmentRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_variable_segment.report_name</code>.
     */
    public final TableField<TCoreVariableSegmentRecord, String> REPORT_NAME = createField(DSL.name("report_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_core_variable_segment.create_report</code>.
     */
    public final TableField<TCoreVariableSegmentRecord, String> CREATE_REPORT = createField(DSL.name("create_report"), SQLDataType.CLOB.defaultValue(DSL.field(DSL.raw("'never'::text"), SQLDataType.CLOB)), this, "");

    /**
     * The column <code>common_dd.t_core_variable_segment.variable_role</code>.
     */
    public final TableField<TCoreVariableSegmentRecord, String> VARIABLE_ROLE = createField(DSL.name("variable_role"), SQLDataType.CLOB.defaultValue(DSL.field(DSL.raw("'key'::text"), SQLDataType.CLOB)), this, "");

    private TCoreVariableSegment(Name alias, Table<TCoreVariableSegmentRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreVariableSegment(Name alias, Table<TCoreVariableSegmentRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_variable_segment</code> table
     * reference
     */
    public TCoreVariableSegment(String alias) {
        this(DSL.name(alias), T_CORE_VARIABLE_SEGMENT);
    }

    /**
     * Create an aliased <code>common_dd.t_core_variable_segment</code> table
     * reference
     */
    public TCoreVariableSegment(Name alias) {
        this(alias, T_CORE_VARIABLE_SEGMENT);
    }

    /**
     * Create a <code>common_dd.t_core_variable_segment</code> table reference
     */
    public TCoreVariableSegment() {
        this(DSL.name("t_core_variable_segment"), null);
    }

    public <O extends Record> TCoreVariableSegment(Table<O> path, ForeignKey<O, TCoreVariableSegmentRecord> childPath, InverseForeignKey<O, TCoreVariableSegmentRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_VARIABLE_SEGMENT);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreVariableSegmentPath extends TCoreVariableSegment implements Path<TCoreVariableSegmentRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreVariableSegmentPath(Table<O> path, ForeignKey<O, TCoreVariableSegmentRecord> childPath, InverseForeignKey<O, TCoreVariableSegmentRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreVariableSegmentPath(Name alias, Table<TCoreVariableSegmentRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreVariableSegmentPath as(String alias) {
            return new TCoreVariableSegmentPath(DSL.name(alias), this);
        }

        @Override
        public TCoreVariableSegmentPath as(Name alias) {
            return new TCoreVariableSegmentPath(alias, this);
        }

        @Override
        public TCoreVariableSegmentPath as(Table<?> alias) {
            return new TCoreVariableSegmentPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreVariableSegmentRecord, Integer> getIdentity() {
        return (Identity<TCoreVariableSegmentRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreVariableSegmentRecord> getPrimaryKey() {
        return Keys.T_CORE_VARIABLE_SEGMENT_PKEY;
    }

    @Override
    public List<UniqueKey<TCoreVariableSegmentRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_VARIABLE_SEGMENT);
    }

    @Override
    public List<ForeignKey<TCoreVariableSegmentRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_VARIABLE_SEGMENT__T_CORE_VARIABLE_SEGMENT_FK_ELEMENT_FKEY);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_VARIABLE_SEGMENT__T_CORE_VARIABLE_SEGMENT_FK_ELEMENT_FKEY, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreVariableSegment as(String alias) {
        return new TCoreVariableSegment(DSL.name(alias), this);
    }

    @Override
    public TCoreVariableSegment as(Name alias) {
        return new TCoreVariableSegment(alias, this);
    }

    @Override
    public TCoreVariableSegment as(Table<?> alias) {
        return new TCoreVariableSegment(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableSegment rename(String name) {
        return new TCoreVariableSegment(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableSegment rename(Name name) {
        return new TCoreVariableSegment(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableSegment rename(Table<?> name) {
        return new TCoreVariableSegment(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableSegment where(Condition condition) {
        return new TCoreVariableSegment(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableSegment where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableSegment where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableSegment where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableSegment where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableSegment where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableSegment where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableSegment where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableSegment whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableSegment whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
